## postgis 2.1.4+dfsg

=== extensions/Makefile ===
#############################################################################
#
# Master makefile used to build extensions
# Copyright (C) 2012 Regina Obe and Leo Hsu <lr@pcorp.us>
# Copyright (C) 2012 Sandro Santilli <strk@keybit.net>
#
# This is free software; you can redistribute and/or modify it under
# the terms of the GNU General Public Licence. See the COPYING file.
#
#############################################################################

SUBDIRS = postgis 
SUBDIRS += postgis_tiger_geocoder 
ifeq (topology,topology)
	SUBDIRS += postgis_topology
endif

all clean distclean install uninstall:
	for DIR in $(SUBDIRS); do \
		echo "---- Making $@ in $${DIR}"; \
		$(MAKE) -C "$${DIR}" $@; \
	done

distclean: distclean-local

distclean-local:
	rm -f Makefile


check:
	@echo "Nothing to check"

=== raster/Makefile ===
#############################################################################
# $Id: Makefile 3940 2009-03-30 09:30:43Z mloskot $
#
# Master makefile used to build WKT Raster
#
# Copyright (c) 2009 Sandro Santilli <strk@keybit.net>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#############################################################################

.NOTPARALLEL:

all:     

corelib:
	$(MAKE) -C rt_core

pglib:
	$(MAKE) -C rt_pg

rtloader:
	$(MAKE) -C loader

rtpostgis.sql:
	$(MAKE) -C rt_pg rtpostgis.sql

install: all
	$(MAKE) -C rt_pg install
	$(MAKE) -C loader install
	$(MAKE) -C scripts install

uninstall:
	$(MAKE) -C rt_pg uninstall
	$(MAKE) -C loader uninstall
	$(MAKE) -C scripts uninstall

clean:
	$(MAKE) -C rt_core $@
	$(MAKE) -C rt_pg $@
	$(MAKE) -C loader $@
	$(MAKE) -C test $@
	$(MAKE) -C scripts $@

distclean: clean
	$(MAKE) -C rt_core $@
	$(MAKE) -C rt_pg $@
	$(MAKE) -C loader $@
	$(MAKE) -C test $@
	$(MAKE) -C scripts $@
	rm -f raster_config.h Makefile

core-check:
	$(MAKE) -C test $@

check:
	$(MAKE) -C test $@

=== extensions/postgis/Makefile ===
include ../upgradeable_versions.mk

EXTENSION     = postgis
EXTVERSION    = 2.1.4
MINORVERSION  = 2.1
GREP = /bin/grep

MICRO_NUMBER  = $(shell echo $(EXTVERSION) | sed "s/[0-9]\.[0-9]\.\([0-9]*\)[a-zA-Z]*[0-9]*/\1/")
PREREL_NUMBER = $(shell echo $(EXTVERSION) | \
                        sed "s/[0-9]\.[0-9]\.\(.*\)/\1/" | \
                        $(GREP) "[a-zA-Z]" | \
                        sed "s/[0-9][a-zA-Z]\([0-9]*\)[a-zA-Z]*/\1/")
MICRO_PREV    = $(shell if test "$(MICRO_NUMBER)x" != "x"; then expr $(MICRO_NUMBER) - 1; fi)
PREREL_PREV   = $(shell if test "$(PREREL_NUMBER)x" != "x"; then expr $(PREREL_NUMBER) - 1; fi)

PREREL_PREFIX = $(shell echo $(EXTVERSION) | \
                        sed "s/[0-9]\.[0-9]\.\(.*\)/\1/" | \
                        $(GREP) "[a-zA-Z]" | \
                        sed "s/\([0-9][a-zA-Z]*\)[0-9]*/\1/")

DATA         = $(filter-out $(wildcard sql/*--*.sql),$(wildcard sql/*.sql))

#DOCS         = $(wildcard ../../doc/html/*.html)
PG_CONFIG    = /var/lib/jenkins/workspace/pg/rel/pg9.2w64/bin/pg_config

PG91         = $(shell $(PG_CONFIG) --version | $(GREP) -qE " 8\.| 9\.0" && echo no || echo yes)
SQL_BITS     = $(wildcard sql_bits/*.sql)
EXTRA_CLEAN += ${SQL_BITS} sql/*.sql


ifeq ($(PG91),yes)
sql/$(EXTENSION).sql: sql_bits/postgis.sql sql_bits/postgis_comments.sql sql_bits/rtpostgis.sql sql_bits/mark_editable_objects.sql.in sql_bits/raster_comments.sql sql_bits/spatial_ref_sys.sql
	mkdir -p sql
	cat $^ > $@
	
all: sql/$(EXTENSION)--$(EXTVERSION).sql sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql sql/$(EXTENSION)--$(EXTVERSION)--$(EXTVERSION)next.sql sql/$(EXTENSION)--$(EXTVERSION)next--$(EXTVERSION).sql sql_minor_upgrade sql_patch_upgrade

sql/$(EXTENSION)--$(EXTVERSION).sql: sql/$(EXTENSION).sql
	mkdir -p sql
	cp $< $@

sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql: sql_bits/postgis--unpackaged.sql.in
	mkdir -p sql
	cp $< $@
	
#this is a cludge to allow upgrading from same SVN to same SVN
sql/$(EXTENSION)--$(EXTVERSION)--$(EXTVERSION)next.sql: sql_bits/extension_upgrade_patch.sql
	cp $< $@
sql/$(EXTENSION)--$(EXTVERSION)next--$(EXTVERSION).sql: sql_bits/extension_upgrade_patch.sql
	cp $< $@

#strip BEGIN/COMMIT since these are not allowed in extensions
sql_bits/spatial_ref_sys.sql: ../../spatial_ref_sys.sql	
	sed -e 's/BEGIN;//g' -e 's/COMMIT;//g'  $< > $@

#strip BEGIN/COMMIT since these are not allowed in extensions
sql_bits/postgis.sql: ../../postgis/postgis.sql
	sed -e 's/BEGIN;//g' -e 's/COMMIT;//g'  $< > $@

../../doc/postgis_comments.sql:
	$(MAKE) -C ../../doc comments

sql_bits/postgis_comments.sql: ../../doc/postgis_comments.sql
	cp $< $@

#strip BEGIN/COMMIT since these are not allowed in extensions
sql_bits/rtpostgis.sql: ../../raster/rt_pg/rtpostgis.sql
	sed -e 's/BEGIN;//g' -e 's/COMMIT;//g'  $< > $@

# we need to also drop this temporary function from the extension
# for casts that are being dropped we need to drop them 
# from extension only if they are in the existension so we use our postgis_extension_drop..
# so that it will silently fail if cast is not in extension
sql_bits/rtpostgis_upgrade_20_21.sql: ../../raster/rt_pg/rtpostgis_upgrade_20_21.sql
	sed -e 's/BEGIN;//g' -e 's/COMMIT;//g' \
		-e 's/DROP FUNCTION _rename_raster_tables();/ALTER EXTENSION ${EXTENSION} DROP FUNCTION _rename_raster_tables();DROP FUNCTION _rename_raster_tables();/g' \
		-e 's/DROP FUNCTION _drop_st_samealignment();/ALTER EXTENSION ${EXTENSION} DROP FUNCTION _drop_st_samealignment();DROP FUNCTION _drop_st_samealignment();/g' \
		-e 's/DROP CAST\(.*\)/SELECT postgis_extension_drop_if_exists('\''$(EXTENSION)'\'', '\''DROP CAST \1'\'');DROP CAST \1/' \
	$< > $@

sql_bits/rtpostgis_upgrade_21_minor.sql: ../../raster/rt_pg/rtpostgis_upgrade_21_minor.sql
	sed -e 's/BEGIN;//g' -e 's/COMMIT;//g' \
		-e 's/DROP FUNCTION _rename_raster_tables();/ALTER EXTENSION ${EXTENSION} DROP FUNCTION _rename_raster_tables();DROP FUNCTION _rename_raster_tables();/g' \
		-e 's/DROP FUNCTION _drop_st_samealignment();/ALTER EXTENSION ${EXTENSION} DROP FUNCTION _drop_st_samealignment();DROP FUNCTION _drop_st_samealignment();/g' \
		-e 's/DROP CAST\(.*\)/SELECT postgis_extension_drop_if_exists('\''$(EXTENSION)'\'', '\''DROP CAST \1'\'');DROP CAST \1/' \
	$< > $@


#don't drop casts just yet since we don't have provision to remove from extension yet
#need to also drop temporary functions from extenions since it gets auto-added
sql_bits/postgis_upgrade_20_21.sql: ../../postgis/postgis_upgrade_20_21.sql 
		 sed -e 's/BEGIN;//g' -e 's/COMMIT;//g' \
		 -e '/^\(DROP\|CREATE\) \(CAST\).*;/d' \
		 -e '/^\(DROP\|CREATE\) \(CAST\)/,/\;/d' \
		 -e 's/DROP FUNCTION postgis_major_version_check();/ALTER EXTENSION ${EXTENSION} DROP FUNCTION postgis_major_version_check();DROP FUNCTION postgis_major_version_check();/g' \
	 	 $< > $@

sql_bits/postgis_upgrade_21_minor.sql: ../../postgis/postgis_upgrade_21_minor.sql 
		 sed -e 's/BEGIN;//g' -e 's/COMMIT;//g' \
		 -e '/^\(DROP\|CREATE\) \(CAST\).*;/d' \
		 -e '/^\(DROP\|CREATE\) \(CAST\)/,/\;/d' \
		 -e 's/DROP FUNCTION postgis_major_version_check();/ALTER EXTENSION ${EXTENSION} DROP FUNCTION postgis_major_version_check();DROP FUNCTION postgis_major_version_check();/g' \
	 	 $< > $@


../../doc/raster_comments.sql:
	$(MAKE) -C ../../doc comments

sql_bits/raster_comments.sql: ../../doc/raster_comments.sql
	cp $< $@

#extension_upgrade_minor.sql is the one that contains both postgis AND raster
#TODO: what about postgis_drop_after.sql ? where does it fit ??
sql_bits/extension_upgrade_minor.sql: ../postgis_extension_helper.sql sql_bits/postgis_upgrade_20_21.sql sql_bits/rtpostgis_upgrade_20_21.sql ../../doc/raster_comments.sql ../../doc/postgis_comments.sql ../postgis_extension_helper_uninstall.sql
	cat $^ > $@

sql_bits/extension_upgrade_patch.sql: ../postgis_extension_helper.sql sql_bits/postgis_upgrade_21_minor.sql sql_bits/rtpostgis_upgrade_21_minor.sql ../../doc/raster_comments.sql ../../doc/postgis_comments.sql ../postgis_extension_helper_uninstall.sql
	cat $^ > $@

# sql_bits/rtpostgis--unpackaged.sql:  ../../raster/rt_pg/rtpostgis.sql	 
# 	sed -e 's/^[\t]*//' \
# 		-e :a -e '$!N; s/,\n/,/; ta' \
# 	$< > $@
#remove leading white space and tabs
#remove line break from a line if it ends in ,

sql_bits/rtpostgis-filtered.sql:  ../../raster/rt_pg/rtpostgis.sql
		sed \
		-e 's/^[\t]*//' \
		$< > $@

## we are going to hard code for now using sql script to generate unpackage script
# sql_bits/rtpostgis--unpackaged.sql:  ../../raster/rt_pg/rtpostgis.sql
# 		sed \
# 		-e 's/^[\t]*//' \
# 		-e '$!N; s/(\n/(/g' \
# 		-e '/^CREATE \(OR REPLACE FUNCTION\|TRIGGER\|TYPE\|TABLE\|VIEW\)/!d;' \
# 		-e 's/OR REPLACE//g' \
# 		-e 's/CREATE\(.*\)/ALTER EXTENSION $(EXTENSION) ADD\1;/' \
# 		-e 's/DEFAULT [^()]\+//g' \
# 		-e 's/\(BEFORE\|AS\|RETURNS\)\(.*\)/;/' \
# 		-e 's/(;/;/' \
# 		-e 's/\\(;/;/' \
# 		-e 's/;;/;/g' $< > $@

# sql_bits/postgis--unpackaged.sql:   ../../postgis/postgis.sql
# 	sed -e '/^CREATE \(OR REPLACE\|TRIGGER\|TYPE\|TABLE\|VIEW\)/!d;' \
# 		-e 's/OR REPLACE//g' \
# 		-e 's/CREATE\(.*\)/ALTER EXTENSION $(EXTENSION) ADD\1;/' \
# 		-e 's/DEFAULT [\.0-9a-zA-Z]\+//g' \
# 		-e 's/\(BEFORE\|AS\|RETURNS\)\(.*\)/;/' \
# 		-e 's/(;/;/' \
# 		-e 's/\\(;/;/' \
# 		-e 's/;;/;/g' $< > $@


sql_minor_upgrade: sql_bits/extension_upgrade_minor.sql
	for OLD_VERSION in $(UPGRADEABLE_VERSIONS_MINOR); do \
  	  cat $< > sql/$(EXTENSION)--$$OLD_VERSION--$(EXTVERSION).sql; \
	done

sql_patch_upgrade: sql_bits/extension_upgrade_patch.sql
	for OLD_VERSION in $(UPGRADEABLE_VERSIONS_PATCH); do \
  	  cat $< > sql/$(EXTENSION)--$$OLD_VERSION--$(EXTVERSION).sql; \
	done

DATA = $(wildcard sql/*--*.sql)
EXTRA_CLEAN += sql/$(EXTENSION)--$(EXTVERSION).sql sql/postgis--unpackaged--$(EXTVERSION).sql
endif

distclean: clean
	rm -f Makefile

PGXS := $(shell $(PG_CONFIG) --pgxs)
include $(PGXS)

=== extensions/postgis_tiger_geocoder/Makefile ===
include ../upgradeable_versions.mk

EXTENSION    = postgis_tiger_geocoder
EXTVERSION    = 2.1.4
MINORVERSION  = 2011.2.1

MICRO_NUMBER  = $(shell echo $(EXTVERSION) | sed "s/[0-9]\.[0-9]\.\([0-9]*\)[a-zA-Z]*[0-9]*/\1/")
PREREL_NUMBER = $(shell echo $(EXTVERSION) | \
                        sed "s/[0-9]\.[0-9]\.\(.*\)/\1/" | \
                        grep "[a-zA-Z]" | \
                        sed "s/[0-9][a-zA-Z]\([0-9]*\)[a-zA-Z]*/\1/")
MICRO_PREV    = $(shell if test "$(MICRO_NUMBER)x" != "x"; then expr $(MICRO_NUMBER) - 1; fi)
PREREL_PREV   = $(shell if test "$(PREREL_NUMBER)x" != "x"; then expr $(PREREL_NUMBER) - 1; fi)

PREREL_PREFIX = $(shell echo $(EXTVERSION) | \
                        sed "s/[0-9]\.[0-9]\.\(.*\)/\1/" | \
                        grep "[a-zA-Z]" | \
                        sed "s/\([0-9][a-zA-Z]*\)[0-9]*/\1/")

DATA         = $(filter-out $(wildcard sql/*--*.sql),$(wildcard sql/*.sql))

PG_CONFIG    =  /var/lib/jenkins/workspace/pg/rel/pg9.2w64/bin/pg_config

PG91         = $(shell $(PG_CONFIG) --version | grep -qE " 8\.| 9\.0" && echo no || echo yes)
SQL_BITS     = $(wildcard sql_bits/*.sql)
EXTRA_CLEAN += sql/*.sql ${SQL_BITS} 


ifeq ($(PG91),yes)
all: sql/$(EXTENSION)--$(EXTVERSION).sql sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql sql/$(EXTENSION)--$(EXTVERSION)--$(EXTVERSION)next.sql sql/$(EXTENSION)--$(EXTVERSION)next--$(EXTVERSION).sql  sql_minor_upgrade

sql/$(EXTENSION)--$(EXTVERSION).sql: sql/$(EXTENSION).sql
	mkdir -p sql
	cp $< $@
	
sql/$(EXTENSION).sql: sql_bits/tiger_geocoder.sql  sql_bits/mark_editable_objects.sql.in sql_bits/tiger_geocoder_comments.sql
	mkdir -p sql
	cat $^ > $@
	
#this is a cludge to allow upgrading from same SVN to same SVN
sql/$(EXTENSION)--$(EXTVERSION)--$(EXTVERSION)next.sql: ../postgis_extension_helper.sql sql_bits/remove_from_extension.sql.in sql/tiger_geocoder_upgrade_minor.sql sql_bits/mark_editable_objects.sql.in sql_bits/tiger_geocoder_comments.sql ../postgis_extension_helper_uninstall.sql
	mkdir -p sql
	cat $^ > $@
sql/$(EXTENSION)--$(EXTVERSION)next--$(EXTVERSION).sql: sql/$(EXTENSION)--$(EXTVERSION)--$(EXTVERSION)next.sql
	mkdir -p sql
	cp $< $@
	
#strip BEGIN/COMMIT since these are not allowed in extensions
#strip CREATE SCHEMA since we force extension 
# to create schema by setting schema to tiger_geocoder in control
sql_bits/tiger_geocoder_minor.sql.in: ../../extras/tiger_geocoder/tiger_2011/utility/set_search_path.sql \
  ../../extras/tiger_geocoder/tiger_2011/tiger_loader_2013.sql \
	../../extras/tiger_geocoder/tiger_2011/utility/utmzone.sql \
	../../extras/tiger_geocoder/tiger_2011/utility/cull_null.sql \
	../../extras/tiger_geocoder/tiger_2011/utility/nullable_levenshtein.sql \
	../../extras/tiger_geocoder/tiger_2011/utility/levenshtein_ignore_case.sql \
	../../extras/tiger_geocoder/tiger_2011/normalize/end_soundex.sql \
	../../extras/tiger_geocoder/tiger_2011/normalize/count_words.sql \
	../../extras/tiger_geocoder/tiger_2011/normalize/state_extract.sql \
	../../extras/tiger_geocoder/tiger_2011/normalize/get_last_words.sql \
	../../extras/tiger_geocoder/tiger_2011/normalize/location_extract_countysub_exact.sql \
	../../extras/tiger_geocoder/tiger_2011/normalize/location_extract_countysub_fuzzy.sql \
	../../extras/tiger_geocoder/tiger_2011/normalize/location_extract_place_exact.sql \
	../../extras/tiger_geocoder/tiger_2011/normalize/location_extract_place_fuzzy.sql \
	../../extras/tiger_geocoder/tiger_2011/normalize/location_extract.sql \
	../../extras/tiger_geocoder/tiger_2011/normalize/normalize_address.sql \
	../../extras/tiger_geocoder/tiger_2011/normalize/pprint_addy.sql \
	../../extras/tiger_geocoder/tiger_2011/pagc_normalize/pagc_tables.sql \
  ../../extras/tiger_geocoder/tiger_2011/pagc_normalize/pagc_normalize_address.sql \
	../../extras/tiger_geocoder/tiger_2011/geocode/other_helper_functions.sql \
	../../extras/tiger_geocoder/tiger_2011/geocode/rate_attributes.sql \
	../../extras/tiger_geocoder/tiger_2011/geocode/includes_address.sql \
	../../extras/tiger_geocoder/tiger_2011/geocode/interpolate_from_address.sql \
	../../extras/tiger_geocoder/tiger_2011/geocode/geocode_address.sql \
	../../extras/tiger_geocoder/tiger_2011/geocode/geocode_location.sql \
	../../extras/tiger_geocoder/tiger_2011/geocode/geocode_intersection.sql \
	../../extras/tiger_geocoder/tiger_2011/geocode/geocode.sql \
	../../extras/tiger_geocoder/tiger_2011/geocode/reverse_geocode.sql \
	../../extras/tiger_geocoder/tiger_2011/geocode/census_tracts_functions.sql
	cat $^ > $@
	
sql_bits/tiger_geocoder.sql.in: sql_bits/norm_addy_create.sql.in \
	../../extras/tiger_geocoder/tiger_2011/utility/set_search_path.sql \
	../../extras/tiger_geocoder/tiger_2011/geocode_settings.sql \
	../../extras/tiger_geocoder/tiger_2011/tables/lookup_tables_2011.sql \
	../../extras/tiger_geocoder/tiger_2011/tiger_loader_2013.sql \
	../../extras/tiger_geocoder/tiger_2011/census_loader.sql \
	../../extras/tiger_geocoder/tiger_2011/utility/set_search_path.sql \
	../../extras/tiger_geocoder/tiger_2011/utility/utmzone.sql \
	../../extras/tiger_geocoder/tiger_2011/utility/cull_null.sql \
	../../extras/tiger_geocoder/tiger_2011/utility/nullable_levenshtein.sql \
	../../extras/tiger_geocoder/tiger_2011/utility/levenshtein_ignore_case.sql \
	../../extras/tiger_geocoder/tiger_2011/normalize/end_soundex.sql \
	../../extras/tiger_geocoder/tiger_2011/normalize/count_words.sql \
	../../extras/tiger_geocoder/tiger_2011/normalize/state_extract.sql \
	../../extras/tiger_geocoder/tiger_2011/normalize/get_last_words.sql \
	../../extras/tiger_geocoder/tiger_2011/normalize/location_extract_countysub_exact.sql \
	../../extras/tiger_geocoder/tiger_2011/normalize/location_extract_countysub_fuzzy.sql \
	../../extras/tiger_geocoder/tiger_2011/normalize/location_extract_place_exact.sql \
	../../extras/tiger_geocoder/tiger_2011/normalize/location_extract_place_fuzzy.sql \
	../../extras/tiger_geocoder/tiger_2011/normalize/location_extract.sql \
	../../extras/tiger_geocoder/tiger_2011/normalize/normalize_address.sql \
	../../extras/tiger_geocoder/tiger_2011/normalize/pprint_addy.sql \
	../../extras/tiger_geocoder/tiger_2011/pagc_normalize/pagc_tables.sql \
    ../../extras/tiger_geocoder/tiger_2011/pagc_normalize/pagc_normalize_address.sql \
	../../extras/tiger_geocoder/tiger_2011/geocode/other_helper_functions.sql \
	../../extras/tiger_geocoder/tiger_2011/geocode/rate_attributes.sql \
	../../extras/tiger_geocoder/tiger_2011/geocode/includes_address.sql \
	../../extras/tiger_geocoder/tiger_2011/geocode/interpolate_from_address.sql \
	../../extras/tiger_geocoder/tiger_2011/geocode/geocode_address.sql \
	../../extras/tiger_geocoder/tiger_2011/geocode/geocode_location.sql \
	../../extras/tiger_geocoder/tiger_2011/geocode/geocode_intersection.sql \
	../../extras/tiger_geocoder/tiger_2011/geocode/geocode.sql \
	../../extras/tiger_geocoder/tiger_2011/geocode/reverse_geocode.sql \
	../../extras/tiger_geocoder/tiger_2011/geocode/census_tracts_functions.sql \
	../../extras/tiger_geocoder/tiger_2011/topology/tiger_topology_loader.sql \
	../postgis_extension_helper.sql \
	sql_bits/add_search_path.sql \
	../postgis_extension_helper_uninstall.sql 
	cat $^ > $@
	
sql_bits/tiger_geocoder.sql: sql_bits/tiger_geocoder.sql.in
	sed -e 's/BEGIN;//g' -e 's/COMMIT;//g' -e '/^CREATE SCHEMA/d;'  $< > $@
	
sql_bits/add_search_path.sql: sql_bits/add_search_path.sql.in
	cp $< $@
	
../../doc/tiger_geocoder_comments.sql:
	$(MAKE) -C ../../doc comments
	
sql_bits/tiger_geocoder_comments.sql: ../../doc/tiger_geocoder_comments.sql
	cp $< $@
	
#grep all lines that start with CREATE OR REPLACE FUNCTION, TRIGGER...
#then replace CREATE OR REPLACE .. with ALTER EXTENSION..;
#then remove default values and extra junk
# sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql: ../../tiger_geocoder/tiger_geocoder.sql
# 	sed -e '/^CREATE \(OR REPLACE\|TYPE\|TABLE\|VIEW\|CAST\)/!d;' \
# 		-e 's/OR REPLACE//g' \
# 		-e 's/CREATE\(.*\)/ALTER EXTENSION $(EXTENSION) ADD\1;/' \
# 		-e 's/DEFAULT [\.0-9a-zA-Z]\+//g' \
# 		-e 's/\(BEFORE\|WITH FUNCTION\)\(.*\)/;/' \
# 		-e 's/[ \t]+;/;/' \
# 		-e 's/(;/;/' \
# 		-e 's/\\(;/;/' \
# 		-e 's/;;/;/g' $< > $@

#hardcode for now using 
#the extensions/make_unpackaged.sql script form an install
sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql: sql_bits/tiger_geocoder--unpackaged.sql.in
	mkdir -p sql
	cp $< $@

#upgrade script should have everything but table, schema, type creation/alter
#NOTE: we assume all object definitions end in ;
#first expression deletes all non-removable objects defined on same line
#second deletes all non-removable defined on multiple lines 
#  the end of the body of object we assume ends in ;
#aggregates are special 
#they can be dropped but we need to remove
#them from the extension first
sql/tiger_geocoder_upgrade_minor.sql:  sql_bits/tiger_geocoder_minor.sql.in 
	mkdir -p sql
	 sed -e '/^\(CREATE\|ALTER\) \(CAST\|TYPE\|TABLE\|SCHEMA\|DOMAIN\|TRIGGER\).*;/d' \
	 	 -e '/^\(CREATE\|ALTER\) \(CAST\|TYPE\|TABLE\|SCHEMA\|DOMAIN\|TRIGGER\)/,/\;/d' \
	 	 -e 's/BEGIN;//g' -e 's/COMMIT;//g' \
	 	 $< > $@
	 	 	
sql_minor_upgrade: ../postgis_extension_helper.sql sql_bits/remove_from_extension.sql.in sql/tiger_geocoder_upgrade_minor.sql sql_bits/mark_editable_objects.sql.in sql_bits/tiger_geocoder_comments.sql ../postgis_extension_helper_uninstall.sql
	for OLD_VERSION in $(UPGRADEABLE_VERSIONS); do \
  	  cat $^ > sql/$(EXTENSION)--$$OLD_VERSION--$(EXTVERSION).sql; \
	done
	
DATA = $(wildcard sql/*--*.sql)
EXTRA_CLEAN += sql/$(EXTENSION)--$(EXTVERSION).sql sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql
endif

distclean: clean
	rm Makefile

PGXS := $(shell $(PG_CONFIG) --pgxs)
include $(PGXS)

=== extensions/postgis_topology/Makefile ===
include ../upgradeable_versions.mk

EXTENSION    = postgis_topology
EXTVERSION    = 2.1.4
MINORVERSION  = 2.1
PGIS_MAJ_MIN=21
GREP=/bin/grep

MICRO_NUMBER  = $(shell echo $(EXTVERSION) | sed "s/[0-9]\.[0-9]\.\([0-9]*\)[a-zA-Z]*[0-9]*/\1/")
PREREL_NUMBER = $(shell echo $(EXTVERSION) | \
                        sed "s/[0-9]\.[0-9]\.\(.*\)/\1/" | \
                        $(GREP) "[a-zA-Z]" | \
                        sed "s/[0-9][a-zA-Z]\([0-9]*\)[a-zA-Z]*/\1/")
MICRO_PREV    = $(shell if test "$(MICRO_NUMBER)x" != "x"; then expr $(MICRO_NUMBER) - 1; fi)
PREREL_PREV   = $(shell if test "$(PREREL_NUMBER)x" != "x"; then expr $(PREREL_NUMBER) - 1; fi)

PREREL_PREFIX = $(shell echo $(EXTVERSION) | \
                        sed "s/[0-9]\.[0-9]\.\(.*\)/\1/" | \
                        $(GREP) "[a-zA-Z]" | \
                        sed "s/\([0-9][a-zA-Z]*\)[0-9]*/\1/")

DATA         = $(filter-out $(wildcard sql/*--*.sql),$(wildcard sql/*.sql))

PG_CONFIG    = /var/lib/jenkins/workspace/pg/rel/pg9.2w64/bin/pg_config

PG91         = $(shell $(PG_CONFIG) --version | $(GREP) -qE " 8\.| 9\.0" && echo no || echo yes)
SQL_BITS     = $(wildcard sql_bits/*.sql)
EXTRA_CLEAN += sql/*.sql ${SQL_BITS}


ifeq ($(PG91),yes)
all: sql/$(EXTENSION)--$(EXTVERSION).sql sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql sql/$(EXTENSION)--$(EXTVERSION)--$(EXTVERSION)next.sql sql/$(EXTENSION)--$(EXTVERSION)next--$(EXTVERSION).sql sql_minor_upgrade

sql/$(EXTENSION)--$(EXTVERSION).sql: sql/$(EXTENSION).sql
	mkdir -p sql
	cp $< $@
	
sql/$(EXTENSION).sql: sql_bits/topology.sql  sql_bits/mark_editable_objects.sql.in sql_bits/topology_comments.sql
	mkdir -p sql
	cat $^ > $@
	
#this is a cludge to allow upgrading from same SVN to same SVN
sql/$(EXTENSION)--$(EXTVERSION)--$(EXTVERSION)next.sql: ../postgis_extension_helper.sql sql_bits/remove_from_extension.sql.in sql/topology_upgrade_minor.sql sql_bits/mark_editable_objects.sql.in sql_bits/topology_comments.sql ../postgis_extension_helper_uninstall.sql
	cat $^ > $@
sql/$(EXTENSION)--$(EXTVERSION)next--$(EXTVERSION).sql: ../postgis_extension_helper.sql sql_bits/remove_from_extension.sql.in sql/topology_upgrade_minor.sql sql_bits/mark_editable_objects.sql.in sql_bits/topology_comments.sql ../postgis_extension_helper_uninstall.sql
	cat $^ > $@
	
#strip BEGIN/COMMIT since these are not allowed in extensions
#strip CREATE SCHEMA since we force extension 
# to create schema by setting schema to topology in control
sql_bits/topology.sql: ../../topology/topology.sql
	sed -e 's/BEGIN;//g' -e 's/COMMIT;//g' -e '/^CREATE SCHEMA/d;'  $< > $@
	
../../doc/topology_comments.sql:
	$(MAKE) -C ../../doc comments
	
sql_bits/topology_comments.sql: ../../doc/topology_comments.sql
	cp $< $@
	
#grep all lines that start with CREATE OR REPLACE FUNCTION, TRIGGER...
#then replace CREATE OR REPLACE .. with ALTER EXTENSION..;
#then remove default values and extra junk
# sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql: ../../topology/topology.sql
# 	sed -e '/^CREATE \(OR REPLACE\|TYPE\|TABLE\|VIEW\|CAST\)/!d;' \
# 		-e 's/OR REPLACE//g' \
# 		-e 's/CREATE\(.*\)/ALTER EXTENSION $(EXTENSION) ADD\1;/' \
# 		-e 's/DEFAULT [\.0-9a-zA-Z]\+//g' \
# 		-e 's/\(BEFORE\|WITH FUNCTION\)\(.*\)/;/' \
# 		-e 's/[ \t]+;/;/' \
# 		-e 's/(;/;/' \
# 		-e 's/\\(;/;/' \
# 		-e 's/;;/;/g' $< > $@

#hardcode for now using 
#the extensions/make_unpackaged.sql script form an install
sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql: sql_bits/topology--unpackaged.sql.in
	mkdir -p sql
	cp $< $@

#upgrade script should have everything but table, schema, type creation/alter
#NOTE: we assume all object definitions end in ;
#first expression deletes all non-removable objects defined on same line
#second deletes all non-removable defined on multiple lines 
#  the end of the body of object we assume ends in ;
#aggregates are special 
#they can be dropped but we need to remove
#them from the extension first
sql/topology_upgrade_minor.sql:  ../../topology/topology_upgrade_$(PGIS_MAJ_MIN)_minor.sql
	 sed -e 's/BEGIN;//g' -e 's/COMMIT;//g' -e '/^CREATE SCHEMA/d;'  $< > $@
	
sql_minor_upgrade: ../postgis_extension_helper.sql sql_bits/remove_from_extension.sql.in sql/topology_upgrade_minor.sql sql_bits/mark_editable_objects.sql.in sql_bits/topology_comments.sql ../postgis_extension_helper_uninstall.sql
	for OLD_VERSION in $(UPGRADEABLE_VERSIONS); do \
  	  cat $^ > sql/$(EXTENSION)--$$OLD_VERSION--$(EXTVERSION).sql; \
	done

DATA = $(wildcard sql/*--*.sql)
EXTRA_CLEAN += sql/$(EXTENSION)--$(EXTVERSION).sql sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql
endif

distclean: clean
	rm Makefile

PGXS := $(shell $(PG_CONFIG) --pgxs)
include $(PGXS)

=== debian/changelog ===
postgis (2.1.4+dfsg-3+deb8u1) jessie-security; urgency=medium

  * Non-maintainer upload by the LTS Team.
  * CVE-2017-18359: denial of service via crafted ST_AsX3D function input

 -- Emilio Pozuelo Monfort <pochu@debian.org>  Thu, 31 Jan 2019 18:24:33 +0100

postgis (2.1.4+dfsg-3) unstable; urgency=high

  * Add patch geojson-fix-3094.patch, back-ported from the 2.1.7 release,
    to fix a crash of the database backend process when given invalid
    GeoJSON data.

 -- Markus Wanner <markus@bluegap.ch>  Mon, 30 Mar 2015 19:40:22 +0200

postgis (2.1.4+dfsg-2) unstable; urgency=medium

  * Add Dutch translation by Frans Spiesschaert. Closes: #765409.
  * Bump S-V: no changes required.

 -- Markus Wanner <markus@bluegap.ch>  Wed, 15 Oct 2014 10:58:52 +0200

postgis (2.1.4+dfsg-1) unstable; urgency=medium

  [ Paulo Flabiano Smorigo ]
  * add -lm for liblwgeom to avoid linkage problem.
  * enable ppc64el.
    (closes: #759505)

  [ Bas Couwenberg ]
  * Add Swedish translation by Martin Bagge. Closes: #761975.
  * Add strip-invalid-whitespace-in-pom.patch to fix mh_cleanpom failure.
  * Update copyright file.
  * Add patch to fix FTBFS on hurd-i386.

  [ Markus Wanner ]
  * New upstream release, 2.1.4. Adapt packaging to the new version.
  * Drop patches debian-versions, fix-armel, use-json-c, and
    postgresql-9.4-fixes.patch, these should be fixed upstream.
  * Refresh patches use-debian-maven, honor-build-flags, and
    enable-ppc64el.patch.
  * Add patch correct-java-version.patch.

 -- Markus Wanner <markus@bluegap.ch>  Sun, 21 Sep 2014 19:39:46 +0200

=== debian/control ===
Source: postgis
Section: misc
Priority: optional
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Stephen Frost <sfrost@debian.org>, Francesco Paolo
 Lovergine <frankie@debian.org>, Markus Wanner <markus@bluegap.ch>,
 Bas Couwenberg <sebastic@xs4all.nl>
Build-Depends: debhelper (>= 9), po-debconf,
 dpkg-dev (>= 1.16.1~), autotools-dev, dh-autoreconf, autoconf2.13,
 flex, bison, rdfind, libgeos-dev (>= 3.3),
 libjson-c-dev | libjson0-dev (>= 0.9~),
 libproj-dev (>= 4.6.0), libssl-dev, xsltproc, docbook, docbook-xsl,
 imagemagick, libcunit1-dev, dblatex, libxml2-dev (>= 2.5.0~),
 libgtk2.0-dev, libgdal-dev (>= 1.9.0~) | libgdal1-dev (>= 1.9.0~),
 postgresql-server-dev-all, postgresql-common (>= 148~), postgresql,
 maven-repo-helper
Build-Depends-Indep: default-jdk,
 libpostgresql-jdbc-java, fastjar, libjts-java (>= 1.7), maven2,
 libmaven-clean-plugin-java, libmaven-jar-plugin-java,
 libsurefire-java, libmaven-compiler-plugin-java,
 libmaven-resources-plugin-java,
 libmaven-javadoc-plugin-java
Standards-Version: 3.9.6
Homepage: http://postgis.refractions.net/
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-grass/postgis.git
Vcs-Git: git://anonscm.debian.org/pkg-grass/postgis.git

Package: postgis
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: postgresql-9.4-postgis-2.1, postgis-doc
Description: Geographic objects support for PostgreSQL
 PostGIS adds support for geographic objects to the PostgreSQL
 object-relational database. In effect, PostGIS "spatially enables"
 the PostgreSQL server, allowing it to be used as a backend spatial
 database for geographic information systems (GIS), much like ESRI's
 SDE or Oracle's Spatial extension. PostGIS follows the OpenGIS
 "Simple Features Specification for SQL".
 .
 This package contains the PostGIS userland binaries, common files.

Package: postgis-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: postgis
Description: Geographic objects support for PostgreSQL -- documentation
 PostGIS adds support for geographic objects to the PostgreSQL
 object-relational database. In effect, PostGIS "spatially enables"
 the PostgreSQL server, allowing it to be used as a backend spatial
 database for geographic information systems (GIS), much like ESRI's
 SDE or Oracle's Spatial extension. PostGIS follows the OpenGIS
 "Simple Features Specification for SQL".
 .
 This package contains the PostGIS documentation.

Package: libpostgis-java
Architecture: all
Section: java
Depends: libpostgresql-jdbc-java, ${misc:Depends}
Suggests: postgresql-9.4-postgis-2.1
Breaks: libpostgis-jdbc, libpostgisjava, postgresql-postgis-java
Replaces: libpostgis-jdbc, libpostgisjava, postgresql-postgis-java
Description: Geographic objects support for PostgreSQL -- JDBC support
 PostGIS adds support for geographic objects to the PostgreSQL
 object-relational database. In effect, PostGIS "spatially enables"
 the PostgreSQL server, allowing it to be used as a backend spatial
 database for geographic information systems (GIS), much like ESRI's
 SDE or Oracle's Spatial extension. PostGIS follows the OpenGIS
 "Simple Features Specification for SQL".
 .
 This package contains JDBC support for PostGIS.

Package: libpostgis-java-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: libpostgis-java
Description: Geographic objects support for PostgreSQL -- JDBC documentation
 PostGIS adds support for geographic objects to the PostgreSQL
 object-relational database. In effect, PostGIS "spatially enables"
 the PostgreSQL server, allowing it to be used as a backend spatial
 database for geographic information systems (GIS), much like ESRI's
 SDE or Oracle's Spatial extension. PostGIS follows the OpenGIS
 "Simple Features Specification for SQL".
 .
 This package contains the documentation for the JDBC support for PostGIS.

Package: liblwgeom-2.1.4
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: PostGIS "Lightweight Geometry" library
 PostGIS adds support for geographic objects to the PostgreSQL
 object-relational database. In effect, PostGIS "spatially enables"
 the PostgreSQL server, allowing it to be used as a backend spatial
 database for geographic information systems (GIS), much like ESRI's
 SDE or Oracle's Spatial extension. PostGIS follows the OpenGIS
 "Simple Features Specification for SQL".
 .
 This library is the generic geometry handling section of PostGIS. The
 geometry objects, constructors, destructors, and a set of spatial
 processing functions, are implemented here.

Package: liblwgeom-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
 liblwgeom-2.1.4 (= ${binary:Version})
Breaks: postgis (<< 2.0.0)
Description: PostGIS "Lightweight Geometry" library - Development files
 PostGIS adds support for geographic objects to the PostgreSQL
 object-relational database. In effect, PostGIS "spatially enables"
 the PostgreSQL server, allowing it to be used as a backend spatial
 database for geographic information systems (GIS), much like ESRI's
 SDE or Oracle's Spatial extension. PostGIS follows the OpenGIS
 "Simple Features Specification for SQL".
 .
 This library is the generic geometry handling section of PostGIS. The
 geometry objects, constructors, destructors, and a set of spatial
 processing functions, are implemented here.  This package contains
 the development files.

Package: postgresql-9.4-postgis-2.1
Depends: ${shlibs:Depends}, postgresql-9.4,
 postgresql-9.4-postgis-scripts, liblwgeom-2.1.4,
 ${misc:Depends}
Recommends: postgis, postgresql-contrib-9.4
Breaks: postgis (<< 1.2.1)
Architecture: any
Description: Geographic objects support for PostgreSQL 9.4
 PostGIS adds support for geographic objects to the PostgreSQL
 object-relational database. In effect, PostGIS "spatially enables"
 the PostgreSQL server, allowing it to be used as a backend spatial
 database for geographic information systems (GIS), much like ESRI's
 SDE or Oracle's Spatial extension. PostGIS follows the OpenGIS
 "Simple Features Specification for SQL".
 .
 This package supports PostgreSQL 9.4.

Package: postgresql-9.4-postgis-scripts
Architecture: all
Depends: ${misc:Depends}
Recommends: postgresql-9.4-postgis-2.1
Replaces: postgresql-9.4-postgis-2.0-scripts (<< 2.1.0~),
 postgresql-9.4-postgis-2.1-scripts (<< 2.1.0-4~)
Breaks: postgresql-9.4-postgis-2.0-scripts (<< 2.1.0~),
 postgresql-9.4-postgis-2.1-scripts (<< 2.1.0-4~)
Description: Geographic objects support for PostgreSQL 9.4 -- scripts
 PostGIS adds support for geographic objects to the PostgreSQL
 object-relational database. In effect, PostGIS "spatially enables"
 the PostgreSQL server, allowing it to be used as a backend spatial
 database for geographic information systems (GIS), much like ESRI's
 SDE or Oracle's Spatial extension. PostGIS follows the OpenGIS
 "Simple Features Specification for SQL".
 .
 This package contains SQL scripts to upgrade from earlier PostGIS
 versions for PostgreSQL 9.4 as well as Perl utility scripts.

Package: postgresql-9.4-postgis-2.1-scripts
Architecture: all
Depends: ${misc:Depends}
Description: PostGIS for PostgreSQL 9.4 -- scripts -- dummy package
 This package contained SQL scripts to upgrade from earlier PostGIS
 versions for PostgreSQL 9.4 as well as Perl utility scripts.
 It got renamed to postgresql-9.4-postgis-scripts.
 .
 This is a transitional dummy package. It can safely be removed.

## postgis 2.1.5+dfsg

=== debian/changelog ===
postgis (2.1.5+dfsg-1~exp2ubuntu1) vivid; urgency=high

  * SECURITY UPDATE: crash of the database backend process when given
    invalid GeoJSON data (LP: #1438875)
    - debian/patches/geojson-fix-3094.patch: back-ported from the 2.1.7
      release, taken from debian patch by Markus Wanner.
    - No CVE number

 -- Johan Van de Wauw <johan.vandewauw@gmail.com>  Wed, 01 Apr 2015 19:53:13 +0200

postgis (2.1.5+dfsg-1~exp2build1) vivid; urgency=medium

  * No-change rebuild for the libgdal-dev 1.11.2 transition.

 -- Adam Conrad <adconrad@ubuntu.com>  Wed, 18 Mar 2015 01:06:20 -0600

postgis (2.1.5+dfsg-1~exp2) experimental; urgency=medium

  * Update symbols for liblwgeom-2.1.5.
  * Update Homepage URL from postgis.refractions.net to postgis.net.
  * Update my email to use @debian.org address.
  * Add build dependency on openjdk-7-jdk | java7-sdk required to build
    libpostgis-java. OpenJDK 7 is not yet available on GNU/Hurd.
  * GNU/Hurd doesn't implement semaphores; skip regress tests on hurd-*.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 08 Feb 2015 21:41:31 +0100

postgis (2.1.5+dfsg-1~exp1) experimental; urgency=medium

  [ Markus Wanner ]
  * Downgrade the recommends on postgis to a suggestion, so we don't ever
    recommend all the way through to another PostgreSQL major version,
    when installing a specific postgresql-X.Y-postgis-2.1 package.

  [ Bas Couwenberg ]
  * New upstream release.
  * Add upstream metadata.
  * Add Brazilian translation by José de Figueiredo. Closes: #771782.
  * Fix get-orig-source path in watch file.
  * Update copyright file, changes:
    - Update copyright years
    - Change config.{sub,guess} license to GPL-3+ with Autoconf exception
    - Remove {extensions,raster}/Makefile, no longer included.
  * Drop enable-ppc64el.patch, applied upstream. Refresh remaining patches.

 -- Bas Couwenberg <sebastic@xs4all.nl>  Wed, 24 Dec 2014 14:49:02 +0100

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: postgis
 Section: misc
 Priority: optional
-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
 Uploaders: Stephen Frost <sfrost@debian.org>, Francesco Paolo
  Lovergine <frankie@debian.org>, Markus Wanner <markus@bluegap.ch>,
- Bas Couwenberg <sebastic@xs4all.nl>
+ Bas Couwenberg <sebastic@debian.org>
 Build-Depends: debhelper (>= 9), po-debconf,
  dpkg-dev (>= 1.16.1~), autotools-dev, dh-autoreconf, autoconf2.13,
  flex, bison, rdfind, libgeos-dev (>= 3.3),
@@ -14,14 +15,14 @@
  libgtk2.0-dev, libgdal-dev (>= 1.9.0~) | libgdal1-dev (>= 1.9.0~),
  postgresql-server-dev-all, postgresql-common (>= 148~), postgresql,
  maven-repo-helper
-Build-Depends-Indep: default-jdk,
+Build-Depends-Indep: default-jdk, openjdk-7-jdk | java7-sdk,
  libpostgresql-jdbc-java, fastjar, libjts-java (>= 1.7), maven2,
  libmaven-clean-plugin-java, libmaven-jar-plugin-java,
  libsurefire-java, libmaven-compiler-plugin-java,
  libmaven-resources-plugin-java,
  libmaven-javadoc-plugin-java
 Standards-Version: 3.9.6
-Homepage: http://postgis.refractions.net/
+Homepage: http://postgis.net/
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-grass/postgis.git
 Vcs-Git: git://anonscm.debian.org/pkg-grass/postgis.git
 
@@ -86,7 +87,7 @@
  .
  This package contains the documentation for the JDBC support for PostGIS.
 
-Package: liblwgeom-2.1.4
+Package: liblwgeom-2.1.5
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -106,7 +107,7 @@
 Architecture: any
 Section: libdevel
 Depends: ${misc:Depends},
- liblwgeom-2.1.4 (= ${binary:Version})
+ liblwgeom-2.1.5 (= ${binary:Version})
 Breaks: postgis (<< 2.0.0)
 Description: PostGIS "Lightweight Geometry" library - Development files
  PostGIS adds support for geographic objects to the PostgreSQL
@@ -123,9 +124,10 @@
 
 Package: postgresql-9.4-postgis-2.1
 Depends: ${shlibs:Depends}, postgresql-9.4,
- postgresql-9.4-postgis-scripts, liblwgeom-2.1.4,
+ postgresql-9.4-postgis-scripts, liblwgeom-2.1.5,
  ${misc:Depends}
-Recommends: postgis, postgresql-contrib-9.4
+Recommends: postgresql-contrib-9.4
+Suggests: postgis
 Breaks: postgis (<< 1.2.1)
 Architecture: any
 Description: Geographic objects support for PostgreSQL 9.4

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

CHECK = check
ifneq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	CHECK =
endif

# Hurd doesn't implement semaphores; skip regress tests
ifeq (hurd,$(DEB_HOST_ARCH_OS))
	CHECK =
endif

# PostgreSQL versions supported by PostGIS 2.0 - for automatic
# generation of transitional -scripts packages.
POSTGIS_2_0_PGVERS = 8.4 9.0 9.1 9.2

# Magic to automatically create a debian/control file for the (or all)
# supported versions of Postgres.
#
# Blatantly copied from
# /usr/share/postgresql-common/pgxs_debian_control.mk and extended to
# support NEWEST_VERSION and fiddle with postgis 2.0 transitional
# packages.
debian/control: debian/control.in debian/pgversions \
			debian/control.postgis-2.0.in
	(set -e; \
	VERSIONS=`pg_buildext supported-versions $(CURDIR)` || exit $$?; \
	NEWEST_VERSION=`pg_buildext supported-versions $(CURDIR) | tail -1` || exit $$?; \
	POSTGIS_2_0_PGVERS="$(POSTGIS_2_0_PGVERS)" ; \
	grep-dctrl -vP PGVERSION $< | \
		sed -e "s:NEWEST_PGVERSION:$$NEWEST_VERSION:" > $@.pgxs_tmp; \
	for v in $$VERSIONS; do \
		grep-dctrl -P PGVERSION $<      \
			| sed -e "s:PGVERSION:$$v:" >> $@.pgxs_tmp; \
		if test "$${POSTGIS_2_0_PGVERS#*$$v}" != "$${POSTGIS_2_0_PGVERS}" ; then \
			grep-dctrl -P PGVERSION debian/control.postgis-2.0.in \
			| sed -e "s:PGVERSION:$$v:" >> $@.pgxs_tmp; \
		fi; \
	done; \
	mv $@.pgxs_tmp $@) || (rm -f $@.pgxs_tmp; exit 1)

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_BUILD_ARCH      ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

# Determine JAVA_HOME to use. Depends on which Build-Depends-Indep
# variant has been used.
JAVA_HOME = /usr/lib/jvm/java-8-openjdk-$(DEB_BUILD_ARCH)
ifeq ("$(wildcard $(JAVA_HOME))","")
  JAVA_HOME = /usr/lib/jvm/java-7-openjdk-$(DEB_BUILD_ARCH)
  ifeq ("$(wildcard $(JAVA_HOME))","")
    JAVA_HOME = /usr/lib/jvm/java-6-openjdk-$(DEB_BUILD_ARCH)
    ifeq ("$(wildcard $(JAVA_HOME))","")
      JAVA_HOME =
    endif
  endif
endif

# Use maven in offline mode and with the local Debian repo
MVN = JAVA_HOME=$(JAVA_HOME) mvn --offline -Dmaven.repo.local=/usr/share/maven-repo

MAJOR_VERSION = $(shell grep POSTGIS_MAJOR_VERSION Version.config|cut -d= -f2)
MINOR_VERSION = $(shell grep POSTGIS_MINOR_VERSION Version.config|cut -d= -f2)
MICRO_VERSION = $(shell grep POSTGIS_MICRO_VERSION Version.config|cut -d= -f2)
POSTGIS_VERSION = $(MAJOR_VERSION).$(MINOR_VERSION).$(MICRO_VERSION)
ifeq ($(POSTGIS_VERSION),..)
$(error Cannot detect Postgis version, fix debian/rules)
endif

# For the Postgres APT repository, we want to support multiple
# Postgres versions. However, docs and the JDBC jar only need to be
# built once - in the main directory.
NEWEST_POSTGRES_VERSION = $(shell pg_buildext supported-versions $(CURDIR)|tail -1)
ifeq ($(NEWEST_POSTGRES_VERSION),)
$(error Cannot detect Postgres version, check debian/pgversions and pg_buildext)
endif

OTHER_POSTGRES_VERSIONS = $(shell pg_buildext supported-versions $(CURDIR)\
	| grep -v "$(NEWEST_POSTGRES_VERSION)")

COMMON_CONFIGURE_ARGS = --host=$(DEB_HOST_GNU_TYPE) \
	--build=$(DEB_BUILD_GNU_TYPE) \
	--prefix=/usr \
	--exec-prefix=\$${prefix} \
	--docdir=\$${prefix}/share/doc \
	--mandir=\$${prefix}/share/man \
	--infodir=\$${prefix}/share/info \
	--with-gui

build: build-arch build-indep

build-arch: build-arch-stamp check
build-arch-stamp: configuration-stamp
#	Build against the newest Postgres version
	$(MAKE)
	$(MAKE) -C doc

#	Build against all other Postgres versions
	(set -e; \
	for PGVER in $(OTHER_POSTGRES_VERSIONS); do \
		$(MAKE) -C $(CURDIR)/debian/build-$$PGVER; \
	done)

	touch $@

build-indep: build-indep-stamp
build-indep-stamp: configuration-stamp
#	Re-check JAVA_HOME
	@[ -n "$(JAVA_HOME)" ] || (echo "ERROR: didn't find a Java JDK"; exit 2)
	@[ -x "$(JAVA_HOME)/bin/javac" ] || (echo "ERROR: no javac in JAVA_HOME=$(JAVA_HOME)"; exit 2)

#	PostGIS JDBC (with debug support)
	cd $(CURDIR)/java/jdbc && $(MVN) package

#	Let PostGIS create a perl script from postgis_restore.pl.in
	$(MAKE) -C utils

#	Create a few SQL scripts that the Makefiles are not clever enough
#	to resolve, when building arch-indep only.
	$(MAKE) -C postgis postgis.sql postgis_upgrade_21_minor.sql
	$(MAKE) -C raster/rt_pg rtpostgis.sql rtpostgis_upgrade_21_minor.sql
	$(MAKE) -C topology topology.sql topology_upgrade_21_minor.sql

#	This creates the required SQL scripts. Again, the Makefile is not
#	clever enough to run this before 'install'.
	$(MAKE) -C extensions

	touch $@

configuration: configuration-stamp
configuration-stamp:
	dh_testdir
	dh_prep -s

#	Run autoreconf *before* coying sources around.
	dh_autoreconf autoconf
	dh_autotools-dev_updateconfig

#	Copy sources required to build extensions for all but the most
#	recent Postgres version. Unfortunately, Postgis doesn't support
#	vpath builds.
	(set -e; \
	for PGVER in $(OTHER_POSTGRES_VERSIONS); do \
		mkdir $(CURDIR)/debian/build-$$PGVER; \
		for FILE in `ls $(CURDIR)|grep -v debian`; do \
			cp -a $$FILE $(CURDIR)/debian/build-$$PGVER; \
		done; \
	done)

#	PostGIS for the most recent PostgreSQL version
	./configure $(COMMON_CONFIGURE_ARGS) \
		--datadir=\$${prefix}/share/postgresql-$(NEWEST_POSTGRES_VERSION)-postgis \
		--with-pgconfig=/usr/lib/postgresql/$(NEWEST_POSTGRES_VERSION)/bin/pg_config

#	PostGIS for all older Postgres versions
	(set -e; \
	for PGVER in $(OTHER_POSTGRES_VERSIONS); do \
		cd $(CURDIR)/debian/build-$$PGVER; \
		./configure $(COMMON_CONFIGURE_ARGS) \
			--datadir=\$${prefix}/share/postgresql-$$PGVER-postgis \
			--with-pgconfig=/usr/lib/postgresql/$$PGVER/bin/pg_config; \
	done)

	touch $@

clean: debian/control
	dh_testdir
	dh_testroot

#	Clean all separate build directories.
	(set -e; \
	for PGVER in $(OTHER_POSTGRES_VERSIONS); do \
		rm -rf $(CURDIR)/debian/build-$$PGVER; \
	done)

	[ ! -f GNUmakefile ] || $(MAKE) distclean || true
	[ ! -f GNUmakefile ] || $(MAKE) -C doc images-clean || true

#	We used to invoke 'mvn clean', but plain 'rm' is a lot quicker and
#	simpler, as it doesn't require all of the Java stuff in B-D, but
#	having it in Build-Depneds-Indep is enough.
	rm -rf $(CURDIR)/java/jdbc/target

#	Cleanup after the Makefile
	rm -f postgis/postgis_upgrade_20_minor.sql.in \
		raster/rt_pg/rtpostgis_drop.sql \
		raster/rt_pg/rtpostgis_upgrade_cleanup.sql

#	Cleanup auto-generated packaging control files
	rm -f $(CURDIR)/debian/postgresql-*-postgis-2.1.install
	rm -f $(CURDIR)/debian/postgresql-*-postgis-scripts.install
	rm -f $(CURDIR)/debian/postgresql-*-postgis-2.0-scripts.postinst
	rm -f $(CURDIR)/debian/postgresql-*-postgis-2.0-scripts.config
	rm -f loader/cunit/cu_tester
	rm -rf liblwgeom/cunit/.libs

#	Cleanup the temporary environment file.
	rm -f postgis-check-env.tmp

	dh_autotools-dev_restoreconfig
	dh_autoreconf_clean
	-mh_clean
	dh_clean

install: install-indep install-arch
install-indep: build-indep
	dh_testdir
	dh_testroot
	dh_prep -i 
	dh_installdirs -i

#	Install the most recent Postgres version. Note that we used to
#	install only utils and extensions. However, there are sql scripts

=== debian/watch ===
version=3
opts=dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)\d*)$/$1~$2/ \
http://download.osgeo.org/postgis/source/ \
(?:.*/|)postgis[\-\._]?([\d\.]+(?:(?:RC|rc|pre|dev|beta|alpha|b|a)\d+)?)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz) \
debian debian/get-orig-source
